package in.techware.carrefour.dbUtils.dao;

import android.arch.persistence.room.Dao;
import android.arch.persistence.room.Delete;
import android.arch.persistence.room.Insert;
import android.arch.persistence.room.OnConflictStrategy;
import android.arch.persistence.room.Query;
import android.arch.persistence.room.Update;

import java.util.List;

import in.techware.carrefour.dbUtils.entity.ItemListEntity;

/**
 * Created by Jemsheer K D on 27 July, 2018.
 * Package in.techware.carrefour.dbUtils.dao
 * Project Carrefour
 */

@Dao
public interface ItemListDao {

    @Query("SELECT * FROM itemList")
    List<ItemListEntity> loadAllItemLists();

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void insertAll(List<ItemListEntity> itemListEntityList);


    @Query("select * from itemList where id = :id ORDER BY id DESC LIMIT 1")
    List<ItemListEntity> getItemList(String id);

    @Query("select * from itemList where sendStatus = 0 ORDER BY id")
    List<ItemListEntity> getAllUnsentItemList();

    @Query("select * from itemList where sendStatus = 1 ORDER BY id")
    List<ItemListEntity> getAllSentItemList();

    @Query("DELETE from itemList where sendStatus = 0")
    void deleteAllUnsentItemList();

    @Query("DELETE from itemList where sendStatus = 1")
    void deleteAllSentItemList();

    @Query("DELETE FROM itemList")
    void deleteAll();

    @Insert
    long insert(ItemListEntity itemListEntity);

    @Update
    void update(ItemListEntity itemListEntity);

    @Delete
    void delete(ItemListEntity itemListEntity);
}
